from .gateway import DeconzGateway as DeconzGateway
from homeassistant.core import callback as callback
from homeassistant.helpers.device_registry import CONNECTION_ZIGBEE as CONNECTION_ZIGBEE
from homeassistant.helpers.dispatcher import async_dispatcher_connect as async_dispatcher_connect
from homeassistant.helpers.entity import DeviceInfo as DeviceInfo, Entity as Entity
from pydeconz.models.group import Group as DeconzGroup
from pydeconz.models.light import LightBase as DeconzLight
from pydeconz.models.scene import Scene as PydeconzScene
from pydeconz.models.sensor import SensorBase as DeconzSensor
from typing import Any

class DeconzBase:
    _device: Any
    gateway: Any
    def __init__(self, device: Union[DeconzGroup, DeconzLight, DeconzSensor, PydeconzScene], gateway: DeconzGateway) -> None: ...
    @property
    def unique_id(self) -> str: ...
    @property
    def serial(self) -> Union[str, None]: ...
    @property
    def device_info(self) -> Union[DeviceInfo, None]: ...

class DeconzDevice(DeconzBase, Entity):
    _attr_should_poll: bool
    TYPE: str
    _attr_name: Any
    def __init__(self, device: Union[DeconzGroup, DeconzLight, DeconzSensor, PydeconzScene], gateway: DeconzGateway) -> None: ...
    async def async_added_to_hass(self) -> None: ...
    async def async_will_remove_from_hass(self) -> None: ...
    def async_update_connection_state(self) -> None: ...
    def async_update_callback(self) -> None: ...
    @property
    def available(self) -> bool: ...

class DeconzSceneMixin(DeconzDevice):
    _device: PydeconzScene
    _attr_name: Any
    _group_identifier: Any
    def __init__(self, device: PydeconzScene, gateway: DeconzGateway) -> None: ...
    def get_device_identifier(self) -> str: ...
    def get_parent_identifier(self) -> str: ...
    @property
    def unique_id(self) -> str: ...
    @property
    def device_info(self) -> DeviceInfo: ...
