import voluptuous as vol
from . import DOMAIN as DOMAIN
from .deconz_event import CONF_DECONZ_EVENT as CONF_DECONZ_EVENT, CONF_GESTURE as CONF_GESTURE, DeconzAlarmEvent as DeconzAlarmEvent, DeconzEvent as DeconzEvent
from .gateway import DeconzGateway as DeconzGateway
from homeassistant.components.automation import AutomationActionType as AutomationActionType, AutomationTriggerInfo as AutomationTriggerInfo
from homeassistant.components.device_automation import DEVICE_TRIGGER_BASE_SCHEMA as DEVICE_TRIGGER_BASE_SCHEMA
from homeassistant.components.device_automation.exceptions import InvalidDeviceAutomationConfig as InvalidDeviceAutomationConfig
from homeassistant.const import CONF_DEVICE_ID as CONF_DEVICE_ID, CONF_DOMAIN as CONF_DOMAIN, CONF_EVENT as CONF_EVENT, CONF_PLATFORM as CONF_PLATFORM, CONF_TYPE as CONF_TYPE, CONF_UNIQUE_ID as CONF_UNIQUE_ID
from homeassistant.core import CALLBACK_TYPE as CALLBACK_TYPE, HomeAssistant as HomeAssistant
from homeassistant.helpers import device_registry as dr
from homeassistant.helpers.typing import ConfigType as ConfigType
from typing import Any

CONF_SUBTYPE: str
CONF_SHORT_PRESS: str
CONF_SHORT_RELEASE: str
CONF_LONG_PRESS: str
CONF_LONG_RELEASE: str
CONF_DOUBLE_PRESS: str
CONF_TRIPLE_PRESS: str
CONF_QUADRUPLE_PRESS: str
CONF_QUINTUPLE_PRESS: str
CONF_ROTATED: str
CONF_ROTATED_FAST: str
CONF_ROTATION_STOPPED: str
CONF_AWAKE: str
CONF_MOVE: str
CONF_DOUBLE_TAP: str
CONF_SHAKE: str
CONF_FREE_FALL: str
CONF_FLIP_90: str
CONF_FLIP_180: str
CONF_MOVE_ANY: str
CONF_DOUBLE_TAP_ANY: str
CONF_TURN_CW: str
CONF_TURN_CCW: str
CONF_ROTATE_FROM_SIDE_1: str
CONF_ROTATE_FROM_SIDE_2: str
CONF_ROTATE_FROM_SIDE_3: str
CONF_ROTATE_FROM_SIDE_4: str
CONF_ROTATE_FROM_SIDE_5: str
CONF_ROTATE_FROM_SIDE_6: str
CONF_TURN_ON: str
CONF_TURN_OFF: str
CONF_DIM_UP: str
CONF_DIM_DOWN: str
CONF_LEFT: str
CONF_RIGHT: str
CONF_OPEN: str
CONF_CLOSE: str
CONF_BOTH_BUTTONS: str
CONF_TOP_BUTTONS: str
CONF_BOTTOM_BUTTONS: str
CONF_BUTTON_1: str
CONF_BUTTON_2: str
CONF_BUTTON_3: str
CONF_BUTTON_4: str
CONF_BUTTON_5: str
CONF_BUTTON_6: str
CONF_BUTTON_7: str
CONF_BUTTON_8: str
CONF_SIDE_1: str
CONF_SIDE_2: str
CONF_SIDE_3: str
CONF_SIDE_4: str
CONF_SIDE_5: str
CONF_SIDE_6: str
HUE_DIMMER_REMOTE_MODEL_GEN1: str
HUE_DIMMER_REMOTE_MODEL_GEN2: str
HUE_DIMMER_REMOTE_MODEL_GEN3: str
HUE_DIMMER_REMOTE: Any
HUE_BUTTON_REMOTE_MODEL: str
HUE_BUTTON_REMOTE: Any
HUE_TAP_REMOTE_MODEL: str
HUE_TAP_REMOTE: Any
FRIENDS_OF_HUE_SWITCH_MODEL: str
FRIENDS_OF_HUE_SWITCH: Any
STYRBAR_REMOTE_MODEL: str
STYRBAR_REMOTE: Any
SYMFONISK_SOUND_CONTROLLER_MODEL: str
SYMFONISK_SOUND_CONTROLLER: Any
TRADFRI_ON_OFF_SWITCH_MODEL: str
TRADFRI_ON_OFF_SWITCH: Any
TRADFRI_OPEN_CLOSE_REMOTE_MODEL: str
TRADFRI_OPEN_CLOSE_REMOTE: Any
TRADFRI_REMOTE_MODEL: str
TRADFRI_REMOTE: Any
TRADFRI_SHORTCUT_REMOTE_MODEL: str
TRADFRI_SHORTCUT_REMOTE: Any
TRADFRI_WIRELESS_DIMMER_MODEL: str
TRADFRI_WIRELESS_DIMMER: Any
AQARA_CUBE_MODEL: str
AQARA_CUBE_MODEL_ALT1: str
AQARA_CUBE: Any
AQARA_DOUBLE_WALL_SWITCH_MODEL: str
AQARA_DOUBLE_WALL_SWITCH_MODEL_2020: str
AQARA_DOUBLE_WALL_SWITCH: Any
AQARA_DOUBLE_WALL_SWITCH_WXKG02LM_MODEL: str
AQARA_DOUBLE_WALL_SWITCH_WXKG02LM: Any
AQARA_DOUBLE_WALL_SWITCH_QBKG12LM_MODEL: str
AQARA_DOUBLE_WALL_SWITCH_QBKG12LM: Any
AQARA_SINGLE_WALL_SWITCH_QBKG11LM_MODEL: str
AQARA_SINGLE_WALL_SWITCH_QBKG11LM: Any
AQARA_SINGLE_WALL_SWITCH_WXKG03LM_MODEL: str
AQARA_SINGLE_WALL_SWITCH_WXKG06LM_MODEL: str
AQARA_SINGLE_WALL_SWITCH: Any
AQARA_MINI_SWITCH_MODEL: str
AQARA_MINI_SWITCH: Any
AQARA_ROUND_SWITCH_MODEL: str
AQARA_ROUND_SWITCH: Any
AQARA_SQUARE_SWITCH_MODEL: str
AQARA_SQUARE_SWITCH: Any
AQARA_SQUARE_SWITCH_WXKG11LM_2016_MODEL: str
AQARA_SQUARE_SWITCH_WXKG11LM_2016: Any
AQARA_OPPLE_2_BUTTONS_MODEL: str
AQARA_OPPLE_2_BUTTONS: Any
AQARA_OPPLE_4_BUTTONS_MODEL: str
AQARA_OPPLE_4_BUTTONS: Any
AQARA_OPPLE_6_BUTTONS_MODEL: str
AQARA_OPPLE_6_BUTTONS: Any
DRESDEN_ELEKTRONIK_LIGHTING_SWITCH_MODEL: str
DRESDEN_ELEKTRONIK_LIGHTING_SWITCH: Any
DRESDEN_ELEKTRONIK_SCENE_SWITCH_MODEL: str
DRESDEN_ELEKTRONIK_SCENE_SWITCH: Any
GIRA_JUNG_SWITCH_MODEL: str
GIRA_SWITCH_MODEL: str
JUNG_SWITCH_MODEL: str
GIRA_JUNG_SWITCH: Any
LEGRAND_ZGP_TOGGLE_SWITCH_MODEL: str
LEGRAND_ZGP_TOGGLE_SWITCH: Any
LEGRAND_ZGP_SCENE_SWITCH_MODEL: str
LEGRAND_ZGP_SCENE_SWITCH: Any
LIDL_SILVERCREST_DOORBELL_MODEL: str
LIDL_SILVERCREST_DOORBELL: Any
LIGHTIFIY_FOUR_BUTTON_REMOTE_MODEL: str
LIGHTIFIY_FOUR_BUTTON_REMOTE_4X_MODEL: str
LIGHTIFIY_FOUR_BUTTON_REMOTE_4X_EU_MODEL: str
LIGHTIFIY_FOUR_BUTTON_REMOTE: Any
BUSCH_JAEGER_REMOTE_1_MODEL: str
BUSCH_JAEGER_REMOTE_2_MODEL: str
BUSCH_JAEGER_REMOTE: Any
SONOFF_SNZB_01_1_MODEL: str
SONOFF_SNZB_01_2_MODEL: str
SONOFF_SNZB_01_SWITCH: Any
TRUST_ZYCT_202_MODEL: str
TRUST_ZYCT_202_ZLL_MODEL: str
TRUST_ZYCT_202: Any
UBISYS_POWER_SWITCH_S2_MODEL: str
UBISYS_POWER_SWITCH_S2: Any
UBISYS_CONTROL_UNIT_C4_MODEL: str
UBISYS_CONTROL_UNIT_C4: Any
REMOTES: Any
TRIGGER_SCHEMA: Any

def _get_deconz_event_from_device(hass: HomeAssistant, device: dr.DeviceEntry) -> Union[DeconzAlarmEvent, DeconzEvent]: ...
async def async_validate_trigger_config(hass: HomeAssistant, config: dict[str, Any]) -> vol.Schema: ...
async def async_attach_trigger(hass: HomeAssistant, config: ConfigType, action: AutomationActionType, automation_info: AutomationTriggerInfo) -> CALLBACK_TYPE: ...
async def async_get_triggers(hass: HomeAssistant, device_id: str) -> Union[list, None]: ...
